#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
using ll = long long;
using namespace std;

struct SegmentTreeSum {
    int s = 1;
    vector<ll> t;

    SegmentTreeSum(int n) {
        while (s < n) s <<= 1;
        t.resize((s + 1) * 2);
    }

    void Change(int i, ll x) {
        i += s - 1;
        t[i] = x;
        for (i >>= 1; i != 0; i >>= 1) {
            t[i] = t[i * 2] + t[i * 2 + 1];
        }
    }

    ll Sum(int l, int r) {
        ll res = 0;
        for (l += s - 1, r += s - 2; l <= r; l >>= 1, r >>= 1) {
            if (l % 2 == 1) res += t[l++];
            if (r % 2 == 0) res += t[r--];
        }
        return res;
    }
};

struct SegmentTreeMin {
    int s = 1;
    vector<ll> t;

    SegmentTreeMin(int n) {
        while (s < n) s <<= 1;
        t.resize((s + 1) * 2);
    }

    void Change(int i, ll x) {
        i += s - 1;
        t[i] = x;
        for (i >>= 1; i != 0; i >>= 1) {
            t[i] = min(t[i * 2], t[i * 2 + 1]);
        }
    }

    ll Min(int l, int r) {
        ll res = 1000000001;
        for (l += s - 1, r += s - 2; l <= r; l >>= 1, r >>= 1) {
            if (l % 2 == 1) res = min(res, t[l++]);
            if (r % 2 == 0) res = min(res, t[r--]);
        }
        return res;
    }
};

int main()
{
    /*int n, k; cin >> n >> k;
    vector<ll> v(n);

    ll mx = 0;
    SegmentTreeSum tr(n);
    SegmentTreeMin tr2(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        mx += v[i];
        tr.Change(i + 1, v[i]);
        tr2.Change(i + 1, v[i]);
    }
    ll mn = 1000000001;
    int l = 0;
    int r = n - 1;
    for (int i = 0; i < k - 1; i++) {
        ll t1s = tr.Sum(l + 1, l + k - 1 - i + 1);
        ll t2s = tr.Sum(1 + r - k + 2 + i, r + 2);
        ll t1m = tr2.Min(l + 1, l + k - 1 - i + 1);
        ll t2m = tr2.Min(1 + r - k + 2 + i, r + 2);
        if (t1s - (t2m - t1m) > t2s) {
            mx -= v[r];
            mn = min(mn, v[r]);
            --r;
        }
        else {
            mx -= v[l];
            mn = min(mn, v[l]);
            ++l;
        }
    }

    cout << mx - mn;*/
    ll d, l, r; cin >> d >> l >> r;
    vector<ll> cv;
    ll temp = 1;
    while (temp * temp <= r) {
        if (temp * temp >= l) {
            cv.push_back(temp * temp - 1000000000);
        }
        temp += 1;
    }
    ll cnt = 0;
    ll i = 0;
    ll j = 1;
    while (j < cv.size()) {
        if (cv[j] - cv[i] == d) {
            ++cnt;
            ++j;
        }
        else if (cv[j] - cv[i] > d) {
            ++i;
        }
        else if (cv[j] - cv[i] < d) {
            ++j;
        }
        if (j == i) ++j;
    }
    cout << cnt;
}